// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	下部表示管理
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ ステージ名クラス
class YmsbBottom{

	arrJSONBottomTxt	= [SbJSON.BOTTOM_TEXT_01,	SbJSON.BOTTOM_TEXT_02];
	BOTTOM_OFF			= 0;
	BOTTOM_FT10			= 1;
	BOTTOM_NEXT			= 2;
	BOTTOM_IMAGE		= 3;
	BOTTOM_TEXT			= 4;

	constructor(moveBox, moveTxt, ft10Opacity) {
		this.ft10 		= new YmsbFT10(moveBox, ft10Opacity);
		this.next		= new Array(2);
		this.next[0]	= new YmsbAnime(0.7, SbCSS.BOX_NEXT_1P, SbCSS.TXT_NEXT_1P,
							YMSB_VIRT, moveBox, YMSB_VIRT, moveTxt,
							ANI_DELY_ON_BOX_BOTTOM, ANI_DELY_ON_TXT_BOTTOM);
		this.next[1]	= new YmsbAnime(0.7, SbCSS.BOX_NEXT_2P, SbCSS.TXT_NEXT_2P,
							YMSB_VIRT, moveBox, YMSB_VIRT, moveTxt,
							ANI_DELY_ON_BOX_BOTTOM, ANI_DELY_ON_TXT_BOTTOM);
		this.vs 		= new YmsbAnime(1.0, "", SbCSS.TXT_NEXT_VS, "", "", YMSB_VIRT, moveBox,
							ANI_DELY_ON_BOX_BOTTOM, ANI_DELY_ON_TXT_BOTTOM);
		this.image		= new YmsbImage(1.0, SbCSS.BOX_BOTTOM, YMSB_VIRT, moveBox, ANI_DELY_ON_BOX_BOTTOM);
		this.txt		= new Array(2);
		this.txt[0]		= new YmsbAnime(1.0, "", SbCSS.TXT_BOTTOM_01, "", "", YMSB_VIRT, moveBox,
							ANI_DELY_ON_BOX_BOTTOM, ANI_DELY_ON_TXT_BOTTOM);
		this.txt[1]		= new YmsbAnime(1.0, "", SbCSS.TXT_BOTTOM_02, "", "", YMSB_VIRT, moveBox,
							ANI_DELY_ON_BOX_BOTTOM, ANI_DELY_ON_TXT_BOTTOM);
		this.currBottom	= YMSB_OFF;
		}

	// 表示
	animeOn() {
		const newBottom = Number(jsonData[SbJSON.BOTTOM_VIEW]);
		switch (newBottom) {
			case this.BOTTOM_FT10:
				this.ft10.animeOn();
				break;
			case this.BOTTOM_NEXT:
				for (let i = 0; i < 2; i++) {
					let newData = jsonData[arrJSONNext[i]];
					this.next[i].animeOn(newData);
				}
				this.vs.animeOn(SB_TXT_NEXT);
				break;
			case this.BOTTOM_IMAGE:
				let cssProp = {"display":"none"}
				const newData  = jsonData[SbJSON.BOTTOM_IMAGE];
				if ("" != newData) {
					cssProp = {
						"display":"block",
						"background-image" : "url(" + YMSB_URL_USER + newData + YMSB_IMAGE_EXT + ")",
						"left"             : arrBottomSize[newBottomSize][BOTTOM_SIZE_LEFT],
						"max-width"        : arrBottomSize[newBottomSize][BOTTOM_SIZE_WIDTH]
					}
				}
				this.image.animeOn(newData, cssProp);
				this.image.currData = newData;
				break;
			case this.BOTTOM_TEXT:
				for (let i = 0; i < 2; i++) {
					let newData = jsonData[this.arrJSONBottomTxt[i]];
					this.txt[i].animeOn(newData);
				}
				break;
			default:
				break;
		}
		this.currBottom = newBottom;
	}

	// 非表示
	animeOff() {
		switch (this.currBottom) {
			case this.BOTTOM_FT10:
				this.ft10.animeOff();
				break;
			case this.BOTTOM_NEXT:
				for (let i = 0; i < 2; i++) {
					this.next[i].animeOff();
				}
				this.vs.animeOff("");
				break;
			case this.BOTTOM_IMAGE:
				this.image.animeOff();
				break;
			case this.BOTTOM_TEXT:
				for (let i = 0; i < 2; i++) {
					this.txt[i].animeOff();
				}
				break;
			default:
				break;
		}
	}

	// 更新
	animeUpdate() {
		const newBottom = Number(jsonData[SbJSON.BOTTOM_VIEW]);
		if (this.currBottom != newBottom) {
			this.animeOff();
			this.animeOn();
		}
		else {
			switch (this.currBottom) {
				case this.BOTTOM_FT10:
					this.ft10.animeUpdate();
					break;
				case this.BOTTOM_NEXT:
					for (let i = 0; i < 2; i++) {
						let newData = jsonData[arrJSONNext[i]];
						if (this.next[i].currData != newData) {
							this.next[i].animeUpdate(newData);
						}
					}
					break;
				case this.BOTTOM_IMAGE:
					let newData  = jsonData[SbJSON.BOTTOM_IMAGE];
					if (
						(this.image.currData != newData) 
					||	(currBottomSize != newBottomSize && "" != newData)
					) {
						let cssProp = {"display":"none"}
						if ("" != newData) {
							cssProp = {
								"display":"block",
								"background-image" : "url(" + YMSB_URL_USER + newData + YMSB_IMAGE_EXT + ")",
								"left"             : arrBottomSize[newBottomSize][BOTTOM_SIZE_LEFT],
								"max-width"        : arrBottomSize[newBottomSize][BOTTOM_SIZE_WIDTH]
							}
						}
						this.image.animeUpdate(newData, cssProp);
						this.image.currData = newData;
					}
					break;
				case this.BOTTOM_TEXT:
					for (let i = 0; i < 2; i++) {
						let newData = jsonData[this.arrJSONBottomTxt[i]];
						if (this.txt[i].currData != newData) {
							this.txt[i].animeUpdate(newData);
						}
					}
					break;
				default:
					break;
			}
		}
		this.currBottom = newBottom;
	}
}
