// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	共通定数/変数
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ スコアボードの表示状態
let currScoreBoard					= YMSB_OFF;
const YMSB_OFF_ON					= 2;
const YMSB_ON_OFF					= 3;

// ■■ 下段表示関連
let currBottomSize					= "";
let newBottomSize					= "";

// ■■ JSONファイル読み出し関連
let jsonData;												// JSONから読みだしたデータ
let currTimeStamp					= 0;					// JSONのタイムスタンプ
let idTimeOut;

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	初期処理・表示処理
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ 初期化関数 ■■
window.onload = function() {
	// 勝利アニメーション処理の初期化
	scWinAnimationInit();

	// 一定時間でJSONファイルを読み込み続ける
	loadJSON();
}

// ■■ JSONファイル読み込み ■■
const loadJSON = () => {
	idTimeOut = setTimeout(async () => {
		let fError = false;
		let cError = "";

		// Googleスプレッドシートからデータ取得
		if (("" != JSON_WebAPI) && (JSON_Remote)){
			resFetch = await fetch(JSON_WebAPI)
				.then(response => {
					if (!response.ok) {
						throw new Error(response.statusText);
					}
					return response.json();
				})
				.then(data => {
					jsonData = data[0];
				})
				.catch(error => {
					fError = true;
					cError = error;
				});
		}
		// ローカルのJSONファイルからデータ取得
		else {
			const data = await fetch(JSON_FILE);
			jsonData = await data.json();
		}

		if (!fError) {
			jQuery("#TxtErrorCode").text("");

			// データからスコアボードを更新
			checkState();
		}
		else {
			jQuery("#TxtErrorCode").text(cError);
		}

		// 再起
		idTimeOut = loadJSON();

	},HANDLER_TIME)
}

// ■■ 終了関数 ■■
window.onbeforeunload = function() {
	clearTimeout(idTimeOut);
}
